#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <TNB.H>
#include <pcmlib.h>
#include "cd2pcm.h"
#include "extern.h"

static char	*REQUEST_MSG[17] = {
	"No Se(0): uɂ́ÁُAȂ\n",
	"Recovered Error (1): û̃gC@\ɂR}hɏI\n",
	"Not Ready (2): ûɈُ킪AIy[^̉Kvł邱Ƃ"
			"\n",
	"Medium Error (3): [h^Cg쎞ɂĔ}̂ɋNG[A"
			"gCŃG[񕜂łȂ\n",
	"Hardware Error (4): ũn[hEFAɏQAR}h̎sI"
			"Ȃ\n",
	"Illegal Request(5):CjVG[^̃R}hEf[^Ɉُ킪AR}h"
			"słȂ\n",
	"Unit Attention (6): uZbgꂽƂBfBAꊷꂽ"
			"Ƃ\n",
	"Write Protected (7): CgEveNgԂɂƂɃCg܂ރR}h"
			"󂯎Ƃ\n",
	"Blank Check (8): ǂ݂ɃuN̈ɂȂB́AݒɃuN"
			"łȂ̈ɂȂ\n",
	"Vendor Unique (9): [J[ƂɎRɎgp\n",
	"Copy Aborted (A): Copy,Compare,Copy & VerifyR}hfoCXُɂ蒆~"
			"\n",
	"Aborted Command (B): ^[QbgCjVG[^̃R}hA{[g"
			"\n",
	"Equal (C): SearchR}hňvo\n",
	"Volume Overflow (D): f[^obt@ɎcĂ̂ɁAfoCX͍ŏIubN"
			"ɒBĂ܂\n",
	"Miscompare (E): \[Xf[^ƃfBAǂݏof[^vȂ\n",
	"(F): ̊gp\n",
			"ZXER}hŃG[A܂B\n"
};

static char	MODE_TBL[2][12] = {
	/* SONY CDU-561 [hύX */
	{ 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x09, 0x30 },
	/*  XM-3401TA audio track 2352 byte */
	{ 0x00, 0x00, 0x00, 0x08, 0x82, 0x00, 0x00, 0x00, 0x00, 0x00, 0x09, 0x30 }
};
static char	MODE_TBL_N[2][12] = {
	/* SONY CDU-561 [hǂ */
	{ 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00 },
	/*  XM-3401TA audio track 2048 byte */
	{ 0x00, 0x00, 0x00, 0x08, 0x82, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00 }
};

static char	SPEED_MODE_TBL[3][16] = {
	/* Wx */
	{ 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x09, 0x30,
	  0x31, 0x02, 0x00, 0x00 },
	/* { */
	{ 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x09, 0x30,
	  0x31, 0x02, 0x01, 0x00 },
	/* ő呬x */
	{ 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x09, 0x30,
	  0x31, 0x02, 0xff, 0x00 }
};

static char	*MODE_MES[3] = {
	"Wx ", "{ ", "ő呬x "
};

unsigned char	erod[2352];	/* errodp[N */
unsigned char	work[2352];	/* Pxǂ݃[N */
unsigned char	work2[2352];	/* Qxǂ݃[N */
unsigned char	work3[2352];	/* Rxǂ݃[N */

/****************************************************************/
/*		I[fBIf[^荞			*/
/****************************************************************/
void cdda2pcm( int music_no, int tstart, int tend )
{
unsigned char buf[256];			/* [J[N */
int	start,end,leadout_address,sta_t,end_t,lng_t,fc;
int	min,max,ll,sss;
int	len,sense,err_cnt;
int	i,frame_cnt;				/* loop count */
int	buffer_size;
char	*buffer_ptr;				/* obt@AhX */
int	escchk=0;
int	cvf=0;
unsigned char *pp;

/*--- PCMLIB  ---*/
PCMFREQ_INIT();		//PCMFREQ();
PCMFFREQ_INIT();	//PCMFFREQ();
PCMFREQVOL_INIT();	//PCMFREQVOL();
PCMFFREQVOL_INIT();	//PCMFFREQVOL();
P162PCM_INIT();		//P162PCM();
PTOA_MAKE_BUFFER();	//PTOA_EXEC();
PTOA_INIT();

trans_size=0;			/* ]TCY */
trans_time=0;			/* ]̂ݎ */

/*--- 荞݃[hύX ---*/
//S_MODESENSE( 0x3f, 12, SCSI_ID, MT_bak );
i=S_MODESELECT( PF, 12, SCSI_ID, MODE_TBL[CDROM_DRIVE] );
if ( i==2 ){
	if ( S_REQUEST( 22, SCSI_ID, buf ) == 0 )
		sense = (unsigned int)( buf[2] & 0x0f );
	else	sense = 16;
	if ( sense!=6 ){
		printf("Check ConditionII Sense Key=%d(ASC=%02X,ASCQ=%02X)\n",sense,buf[12],buf[13]);
		printf( REQUEST_MSG[sense] );
		if ( inqu_sw!=0 && CDROM_DRIVE==TOSHIBATYPE )
			printf(" TOSHIBAn Read CD-DA R}h̓T|[gĂȂ悤łB\n");
		if ( errjmp_fg==0 )		/* vIłȂG[͖܂B*/
			EndtDisp(1);
	}
} else if ( i!=0 ){
	printf("G[o܂B[h͕ύXo܂łB\n");
	if ( errjmp_fg==0 )		/* vIłȂG[͖܂B*/
		EndtDisp(1);
}
/*--- 荞ݑxύX(MMC) ---*/
if ( cdspeed>0 ){
	i=SetSpeed( 706*cdspeed/4 );
	if ( i!=0 )
		printf("Set Speed Command ŃG[o܂B\n");
	if ( i==2 ){
		if ( S_REQUEST( 22, SCSI_ID, buf ) == 0 )
			sense = (unsigned int)( buf[2] & 0x0f );
		else	sense = 16;
		if ( sense==5 ){
			if ( buf[12]==0x20 )
				printf(" CD-ROM hCuΉĂȂ\܂B\n");
			else	printf(" CD-ROM hCȗΉ͈͂zĂ\܂B\n");
			if ( errjmp_fg==0 )		/* vIłȂG[͖܂B*/
				EndtDisp(1);
		} else if ( sense!=6 ){
			printf("Check ConditionII Sense Key=%d(ASC=%02X,ASCQ=%02X)\n",sense,buf[12],buf[13]);
			printf( REQUEST_MSG[sense] );
			if ( errjmp_fg==0 )		/* vIłȂG[͖܂B*/
				EndtDisp(1);
		}
	} else if ( i!=0 ){
		if ( errjmp_fg==0 )		/* vIłȂG[͖܂B*/
			EndtDisp(1);
	}
}
/*--- SONYn ANZXxύX ---*/
if ( cd_speed != -1 && CDROM_DRIVE == CD_CDU561 ){
	/* CD xύX */
	i=S_MODESELECT( PF, 16, SCSI_ID, SPEED_MODE_TBL[cd_speed] );
	if ( i==0 ){
		printf("bc|qnlANZXx́A");
		printf(MODE_MES[cd_speed]);
		printf("ɕύX܂B\n");
	} else if ( i==2 ){
		if ( S_REQUEST( 22, SCSI_ID, buf ) == 0 )
			sense = (unsigned int)( buf[2] & 0x0f );
		else	sense = 16;
		if ( sense!=6 ){
			printf("Check ConditionII Sense Key=%d(ASC=%02X,ASCQ=%02X)\n",sense,buf[12],buf[13]);
			printf( REQUEST_MSG[sense] );
			if ( errjmp_fg==0 )		/* vIłȂG[͖܂B*/
				EndtDisp(1);
		}
	} else {
		printf("G[o܂B[h͕ύXo܂łB\n");
		if ( errjmp_fg==0 )		/* vIłȂG[͖܂B*/
			EndtDisp(1);
	}
}

/*--- [̃`FbN ---*/
len = 2352;				/* 44.1 kHz 16 bit streo 1/75 s */
buffer_size = (int)MALLOC( 0x00ffffff );
buffer_size = buffer_size & 0x00ffffff;
if ( buffer_size < len ){
	/* SR */
	printf("[AȂ̂ŁAsł܂B\n");
	EndtDisp(1);
}
/*--- [m ---*/
buffer_ptr = MALLOC( buffer_size );	/* G[ԂĂȂ */
if ( pcm_mode!=CONVERT_A88 ){
	frame_cnt = (buffer_size-2) / len ;		/* t[߂ */
} else {
	frame_cnt = ((buffer_size-2) / len)/4 ;		/* t[߂ */
}
if ( buf_size != -1 ){
	buf_size = buf_size * 75;		/* w肳ꂽt[ */
	if ( buf_size > frame_cnt ){
		printf(" %db̃mۏo܂łB\n",buf_size/75);
		printf(" %db̃ŏs܂B\n",frame_cnt/75);
	} else
		frame_cnt = buf_size;
}
CDPCM_ptr  = buffer_ptr;				/* CD ̃obt@AhXZbg */
CDPCMM_ptr = CDPCM_ptr+((buffer_size/2)&0xFFFFFFFE);	/* monoɂȂ딼̓[N*/
/*--- CD `FbNI ---*/
if ( RedTOC( &leadout_address, &min, &max ) != 0 ){
	printf(" Read TOC ŃG[Ał܂B\n");
	EndtDisp(1);
}
/*--- 荞݃AhXvZ ---*/
if ( music_no == -1 ){
	if ( adr2time(leadout_address) - 1 < tstart ){
		printf("ǂݍ݊JnԂ̐ݒ肪傫܂B\n");
		EndtDisp(1);
	}
	if ( tend == -1 )
		tend = adr2time(leadout_address) -1;
	if ( adr2time(leadout_address) -1 +1 < tend ){
		printf("ǂݍݏIԂ̐ݒ肪傫܂B\n");
		EndtDisp(1);
	}
	start = tstart;
	end   = tend + 1;
} else {
	if ( Music_inf( music_no, &start ) != 0 ){
		printf(" Music_inf ŃG[Ał܂B\n");
		EndtDisp(1);
	}
	start = adr2time( start );
	if ( music_no == max ){
		end   = adr2time( leadout_address )-1;
	} else {
		if ( Music_inf( music_no+1 , &end ) != 0 ){
			printf("Start Track Address or ReadTOC Command error ̂ߓǂݍݏo܂łB\n");
			EndtDisp(1);
		}
		end   = adr2time( end );
	}
}

/*--- t@C쐬 ---*/
if ( test_fg==0 && merc_fg==0 ){
	hdl = CREATE( outfile, 0x20 );
	if ( hdl < 0 ){
		printf("t@C̍쐬Ɏs܂B\n");
		printf("errcode = %d\n",hdl );
		EndtDisp(1);
	}
	if ( adpcm_flg == 2 ){
		/*-- WAV ̃wb_ --*/
		char	buf[64];
		WRITE(hdl,buf,44);	//S~Ă
	}
} else {
	if ( merc_fg ){
		printf(" ܁[[t mode\n");
	} else {
		printf(" Read CD-DA test mode\n");
	}
}
write_size = 0;				/* DISKɏ񂾃TCY*/
C_CUROFF();		/* J[\ */
printf("\x1B""0");
/*------ I[fBIf[^荞 ------*/
sta_t	= bin2time( start + 75 * 2 );
end_t	= bin2time( end + 75 * 2 -1 );
lng_t	= bin2time( (end-start) );
if ( music_no != -1 ){
	char	*s;
	if ( CDC_ID==SCSI_ID )
		s=CDCTNAME(music_no);
	else	s=0;
	if ( s==0 )
		printf(" %d Ȗڂǂݍ݂܂B\n",music_no );
	else	printf(" %d Ȗ[%s]ǂݍ݂܂B\n",music_no,NameCenter(s) );
}
printf("捞 %2d%02db%02d`%2d%02db%02d (%2d%02db%02d)\n\n",
	( sta_t >> 16 ) & 0xff, ( sta_t >> 8 ) & 0xff, sta_t & 0xff,
	( end_t >> 16 ) & 0xff, ( end_t >> 8 ) & 0xff, end_t & 0xff,
	( lng_t >> 16 ) & 0xff, ( lng_t >> 8 ) & 0xff, lng_t & 0xff
);
srand(ONTIME());
memset( buf, 0x00, 12 );
sss=start;
cvf=0;
if ( pcm_mode!=0 && pcm_mode!=CONVERT_PCMA )
	sct_fg = 0;			/* SCSITAI gptO*/
for(i=0;start<end;){
	pp=(unsigned char*)&CDPCM_ptr[i*2352];
	if ( dma_fg!=0 && mach2_fg==0 && (pcm_mode==0 || pcm_mode==CONVERT_PCMA) ){
		// DMA ] Mach2 łȂ pcms | pcma ̎
		pp++;		// ()
	}
	CURDRV();
	if ( CDROM_DRIVE == CD_CDU561 ){
		/* SONY CDU-561 gbNǂݍ݃R}h */
		buf[0] = 0xd8;			// 1101_1000  ٰ 6
		buf[2] = (start >> 24)&0xff;
		buf[3] = (start >> 16)&0xff;
		buf[4] = (start >>  8)&0xff;
		buf[5] = (start      )&0xff;
		buf[8] = 0;
		buf[9] = 1;		/* 1 block */
	} else {
		/*  XM-3401TA gbNǂݍ݃R}h */
		buf[0] = 0x28;		// g[hR}h 0010_8000  ٰ 1
		buf[2] = (start >> 24)&0xff;
		buf[3] = (start >> 16)&0xff;
		buf[4] = (start >>  8)&0xff;
		buf[5] = (start      )&0xff;
		buf[7] = 0;
		buf[8] = 1;		/* 1 block */
	}
	sta_t = bin2time( start + 75 * 2 );
	if ( check_fg == 0 ){
		printf_( CFC CUP );
		/*--- ǂݍ ---*/
		if ( secone_fg==0 ){
			ll=(end-start);
			if ( ll>65535 )
				ll=65535;
			if ( ll>(frame_cnt-i) ){
				ll=(frame_cnt-i);
				cvf=1;
			}
			if ( CDROM_DRIVE == CD_CDU561 ){
				buf[8]=ll/0x100;
				buf[9]=ll&0xFF;
			} else {
				buf[7]=ll/0x100;
				buf[8]=ll&0xFF;
			}
			end_t = bin2time( start+75*2+ll-1 );
			lng_t = bin2time( ll );
			printf_(" %2d%02db%02d`%2d%02db%02d (%2d%02db%02d)\n",
				( sta_t >> 16 ) & 0xff, ( sta_t >> 8 ) & 0xff, sta_t & 0xff,
				( end_t >> 16 ) & 0xff, ( end_t >> 8 ) & 0xff, end_t & 0xff,
				( lng_t >> 16 ) & 0xff, ( lng_t >> 8 ) & 0xff, lng_t & 0xff
			);
			printf_(" Read CD-DA" CFC "\n" CUP);
		} else {
			ll=1;
			printf_(" %2d%02db%02d\n",
				( sta_t >> 16 ) & 0xff, ( sta_t >> 8 ) & 0xff, sta_t & 0xff
			);
		}

//		if ( mbr7f )
//			l1=3;
//		else	l1=1;
//		for(;l1>0;l1--)
//			ReadCDDA(12, buf, 2352*ll,pp);

		if ( mbr7f ){
			S_REZEROUNIT(SCSI_ID);
			S_SEEK(0,SCSI_ID);
		}

		ReadCDDA(12, buf, 2352*ll,pp);

	} else {
		printf_( CUP );
		/*--- `FbNȂǂݍ ---*/
		printf_(" %2d%02db%02d\n",
			( sta_t >> 16 ) & 0xff, ( sta_t >> 8 ) & 0xff, sta_t & 0xff
		);
		ll=1;
		err_cnt = 1;
		ReadCDDA(12,buf,2352,work);
		for(;;)	{
			while( (BITSNS(0xA)&(1<<5))!=0 );	//[XF1]Ă҂
			ReadCDDA(12,buf,2352,work2);
			if ( check_fg==1 ){
				fc=memfcmp( work, work2, 2352 ,fcmppr );
				if ( fc==0 ){
					printf_(" 1xڂ2xڂv܂B%d" CFC "\n" CUP,err_cnt);
					memcpy( pp,work,2352 );
					break;
				} else if ( fc==1 ){
					printf_(" 1xڂ2xڂ%dv܂B%d" CFC "\n" CUP,fcmppr,err_cnt);
					memcpy( pp,work,2352 );
					break;
				}
			}
			if ( err_cnt>=40 ){
				WW((rand()%50)+8);
			} else if ( err_cnt>=20 && (err_cnt%8)==0 ){
				/*8ɂPx*/
				WW(45);
			}
			while( (BITSNS(0xA)&(1<<5))!=0 );	//[XF1]Ă҂
			ReadCDDA(12,buf,2352,work3);
			if ( check_fg==1 ){
				fc=memfcmp( work, work3, 2352,fcmppr );
				if ( fc== 0 ){
					printf_(" 1xڂ3xڂv܂B%d" CFC "\n" CUP,err_cnt);
					memcpy( pp,work,2352 );
					break;
				} else if ( fc== 1 ){
					printf_(" 1xڂ3xڂ%dv܂B%d" CFC "\n" CUP,fcmppr,err_cnt);
					memcpy( pp,work,2352 );
					break;
				}
				fc=memfcmp( work2, work3, 2352,fcmppr );
				if ( fc== 0 ){
					printf_(" 2xڂ3xڂv܂B%d" CFC "\n" CUP,err_cnt);
					memcpy( pp,work2,2352 );
					break;
				} else if ( fc== 1 ){
					printf_(" 3xڂ3xڂ%dv܂B%d" CFC "\n" CUP,fcmppr,err_cnt);
					memcpy( pp,work,2352 );
					break;
				}
			} else {
				//}jAbN
				if ( memfcmp( work,work2,2352,fcmppr )==0 && memfcmp( work,work3,2352,fcmppr )==0 ){
					printf_(" 3Aňv܂B%d" CFC "\n" CUP,err_cnt);
					memcpy( pp,work,2352 );
					break;
				}
			}
			err_cnt++;
			if ( check_fg==1 && err_cnt>=5+1 && (BITSNS(0xE)&1)==0 ){
				printf_(" gCI[o[łBŏ̃f[^LƂ܂B" CFC "\n" CUP);
				memcpy( pp, work,2352 );
				break;
			}
			printf_(" Checking...%5d"CFC"\n"CUP,err_cnt);
			memcpy( work,work3,2352 );
			if ( err_cnt>=40 ){
				WW((rand()%68)+8);
			} else if ( err_cnt>=20 ){
				if ( (err_cnt%4)==0 ){
					/*4ɂPx*/
					WW(68);
				}
			} else if ( err_cnt>=10 && (err_cnt%10)==0 ){
				/*10ɂPx*/
				WW(68);
			}
			if ( (BITSNS(0)&2)!=0 ){	//[ESC]Ă
				escchk=1;
				break;
			}
		}
		if ( escchk!=0 )
			break;
	}
	i+=ll;
	if ( (BITSNS(0)&2)!=0 ){	//[ESC]Ă
		escchk=1;
		break;
	}
	if ( i==frame_cnt || cvf ){
		len = 2352*i;
		i = 0;
		convert( len );
		cvf=0;
	}
	start+=ll;
	if ( (BITSNS(0)&2)!=0 ){	//[ESC]Ă
		escchk=1;
		break;
	}
}
printf("\x1B""1");
if ( escchk!=0 )
	printf( CUP CFC " ǂݍ݂𒆎~܂B\n");
if ( i!=0 ){
	/* c */
	len = 2352 * i;
	convert( len );
}
if ( adpcm_flg==2 && test_fg==0 ){
	/*-- WAV ̃wb_␳ --*/
	static char header1[]= "RIFF";
	static char header2[]={
		 'W', 'A', 'V', 'E', 'f',  'm', 't',0x20,0x10,0x00,
		0x00,0x00,0x01,0x00,0x01, 0x00,0x22,0x56,0x00,0x00,
		0x22,0x56,0x00,0x00,0x01, 0x00,0x08,0x00, 'd', 'a',
		 't', 'a'
	};
	char buf[8];
	int	j;
	header2[20-8]=1;	/*1=obl  0x20=`cobl */
	header2[22-8]=2;	/*1=m 2=XeI*/
	header2[34-8]=0x10;	/*0x08=8rbg 0x10=16rbg*/
	header2[32-8]=1;	/*킩Ȃ ;_; */
	/*TvOg*/
	header2[24-8]= pcm_rate & 0xFF;
	header2[25-8]= pcm_rate / 0x100;
	j = write_size + 36;
	SEEK( hdl, 0, 0);
	WRITE( hdl,header1,4);
	buf[0]=  j        & 0xff;
	buf[1]= (j >>  8) & 0xff;
	buf[2]= (j >> 16) & 0xff;
	buf[3]= (j >> 24) & 0xff;
	WRITE(hdl,buf,4);
	WRITE(hdl,header2,32);
	buf[0]= write_size        & 0xff;
	buf[0]=(write_size >>  8) & 0xff;
	buf[0]=(write_size >> 16) & 0xff;
	buf[0]=(write_size >> 24) & 0xff;
	WRITE(hdl,buf,4);
}
if ( test_fg==0 ){
	CLOSE( hdl );
	printf( CUP CFC "\nI[fBIf[^̓ǂݍ݂");
} else {
	printf( CUP CFC "\nI[fBIf[^̃eXgǂ݂");
}
if ( escchk==0 ){
	printf("I܂B\n");
} else {
	printf("rI܂B\n");
	while( (BITSNS(0)&2)!=0 );	//[ESC]Ă҂
}
if ( retry_fg!=0 ){		/* -retry[n] ǂݍ݃G[oꍇ[n]񒧐*/
	if ( retry_mx>1 )
		printf("	ő僊gC %d\n",retry_mx);
}
if ( errjmp_fg!=0 ){			/* vIłȂG[͖܂B*/
	printf("	vIG[ %d\n",errjmp_mx);
}
/* Ԃ\ */
if ( trans_time>50 && secone_fg==0 ){
	printf(" Read CD-DA :  %.1fKB/s  < %.2f{ >\n",
		(((double)trans_size)*100.*150)/(((double)trans_time)*75.),
		(((double)trans_size)*100.)/(((double)trans_time)*75.)
	);
}
C_CURON();
/*---ubNTCY߂---*/
i=S_MODESELECT( PF, 12, SCSI_ID, MODE_TBL_N[CDROM_DRIVE] );
if ( i==2 ){
	if ( S_REQUEST( 22, SCSI_ID, buf ) == 0 )
		sense = (unsigned int)( buf[2] & 0x0f );
	else	sense = 16;
	if ( sense!=6 ){
		printf("Check ConditionII Sense Key=%d(ASC=%02X,ASCQ=%02X)\n",sense,buf[12],buf[13]);
		printf( REQUEST_MSG[sense] );
		//if ( inqu_sw!=0 && CDROM_DRIVE==TOSHIBATYPE )
		//	printf(" TOSHIBAn Read CD-DA R}h̓T|[gĂȂ悤łB\n");
		//if ( errjmp_fg==0 )		/* vIłȂG[͖܂B*/
		//	EndtDisp(1);
	}
} else if ( i!=0 ){
	printf("G[o܂BubNTCYύXꂽ܂܂łB\n");
	//if ( errjmp_fg==0 )		/* vIłȂG[͖܂B*/
	//	EndtDisp(1);
}
SetSpeed( 0xFFFF );		// ő呬xɂĂB
}
/*++*/
void	WW(int w)	// 1/100s
{
int	i,j;
i=ONTIME();
for(;;){
	if ( (j=ONTIME()-i)<0 )
		 j+=8639999;
	if ( j>=w )
		break;
}
}
/****************************************/
/*	READ CD-DA			*/
/****************************************/
void	ReadCDDA(cml,com,lg,ad)
int	cml,lg;
char	*com,*ad;
{
int	i,n,l,rc,sense,b,i8;
unsigned char	buf[256];
int	t1,t2;
n=retry_fg;
sense=-1;
if ( n<=0 ) n=1;
for(l=0;l<n;l++){
	for(i8=0;i8<10;i8++){
		b=BREAKCK(-1);
		BREAKCK(2);
		t1=ONTIME();	// Jn
		rc=scsi_cmd__(cml,com,lg,ad);
		t2=ONTIME();	// I
		BREAKCK(b);
		if ( rc!=8 )
			break;
	}
	if ( rc==0 ){
		//薳
		if ( errjmp_fg && errod_fg && secone_fg )
			memcpy( erod,ad,2352 );
		if ( retry_mx<l )
			retry_mx=l;		/* G[̍ő僊gC */
		trans_size+=(lg/2352);			/* ]TCY */
		i=t2-t1;
		if ( i<0 )
			i+=8640000;
		trans_time+=i;			/* ]̂ݎ */
		return;
	}
	if ( rc==0x02 ){
		/* `FbNERfBV */
		if ( S_REQUEST( 22, SCSI_ID, buf ) == 0 )
			sense = (unsigned int)( buf[2] & 0x0f );
		else	sense = 16;
		if ( sense==0xB || sense==0x6 ){
					//0x0B ; ^[Qbg̓R}h̎s
					//	I̓X[(PD-DRIVEȊO
					//	ŏô͂Ȃ)
					//0x06 ; ĂłBȂ
			if ( errjmp_fg && errod_fg && secone_fg )
				memcpy( erod,ad,2352 );
			if ( retry_mx<l )
				retry_mx=l;		/* G[̍ő僊gC */
			n++;
			continue;
		} else {
			printf("\nCheck ConditionII Sense Key=%d(ASC=%02X,ASCQ=%02X)\n",sense,buf[12],buf[13]);
		}
	} else {
		sense=-1;
		if ( inqu_sw!=0 && CDROM_DRIVE==CD_CDU561 )
			printf(" \nSONYn Read CD-DA R}h̓T|[gĂȂ悤łB  (%d)\n" CUP CUP,l+1);
		else	printf_("\nRead CD-DA Command ErrII   (%d)\n" CUP CUP,l+1);
	}
	if ( mbr7f ){
		S_REZEROUNIT(SCSI_ID);
		S_SEEK(0,SCSI_ID);
	}
}
if ( errjmp_fg ){		/* vIłȂG[͖܂B*/
	errjmp_mx++;			/* vIłȂG[̐ */
	/*G[Ȃ̂ŁA00𖄂߂ĕԂ*/
	if ( errod_fg && secone_fg ){
		memcpy( ad,erod,2352 );
		return;
	}
	memset( ad, 0x00, lg );
	return;
}
printf("\n\n");
if ( sense>=0 )
	printf( REQUEST_MSG[sense] );
if ( test_fg==0 )
	CLOSE(hdl);
EndtDisp(1);
}
/*************************************
	er
[߂l] 0 ; v
	-1 ; SRႤ
	 1 ; nv
*************************************/
int	memfcmp(ad1,ad2,l,n)
unsigned char *ad1,*ad2;
int	l,n;
{
int	ll,ep;
ll=l;
ep=0;
for(;l>0;l--){
	if ( *ad1++==*ad2++ ){
		ep++;
	} else {
		if ( n==0 )
			return(-1);
	}
}
if ( ep==ll )
	return(0);
if ( ep*100/ll>n )
	return(1);
return(-1);
}
